/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ExternalSystemLink type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExternalSystemLink{}

// ExternalSystemLink struct for ExternalSystemLink
type ExternalSystemLink struct {
	// External sytem name as defined in organization settings
	SystemName string `json:"system_name"`
	// User ID or full profile page URL as defined in organization settings
	UserLink string `json:"user_link"`
}

// NewExternalSystemLink instantiates a new ExternalSystemLink object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExternalSystemLink(systemName string, userLink string) *ExternalSystemLink {
	this := ExternalSystemLink{}
	this.SystemName = systemName
	this.UserLink = userLink
	return &this
}

// NewExternalSystemLinkWithDefaults instantiates a new ExternalSystemLink object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExternalSystemLinkWithDefaults() *ExternalSystemLink {
	this := ExternalSystemLink{}
	return &this
}

// GetSystemName returns the SystemName field value
func (o *ExternalSystemLink) GetSystemName() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.SystemName
}

// GetSystemNameOk returns a tuple with the SystemName field value
// and a boolean to check if the value has been set.
func (o *ExternalSystemLink) GetSystemNameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.SystemName, true
}

// SetSystemName sets field value
func (o *ExternalSystemLink) SetSystemName(v string) {
	o.SystemName = v
}

// GetUserLink returns the UserLink field value
func (o *ExternalSystemLink) GetUserLink() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UserLink
}

// GetUserLinkOk returns a tuple with the UserLink field value
// and a boolean to check if the value has been set.
func (o *ExternalSystemLink) GetUserLinkOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UserLink, true
}

// SetUserLink sets field value
func (o *ExternalSystemLink) SetUserLink(v string) {
	o.UserLink = v
}

func (o ExternalSystemLink) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExternalSystemLink) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["system_name"] = o.SystemName
	toSerialize["user_link"] = o.UserLink
	return toSerialize, nil
}

type NullableExternalSystemLink struct {
	value *ExternalSystemLink
	isSet bool
}

func (v NullableExternalSystemLink) Get() *ExternalSystemLink {
	return v.value
}

func (v *NullableExternalSystemLink) Set(val *ExternalSystemLink) {
	v.value = val
	v.isSet = true
}

func (v NullableExternalSystemLink) IsSet() bool {
	return v.isSet
}

func (v *NullableExternalSystemLink) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExternalSystemLink(val *ExternalSystemLink) *NullableExternalSystemLink {
	return &NullableExternalSystemLink{value: val, isSet: true}
}

func (v NullableExternalSystemLink) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExternalSystemLink) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


